﻿using System;
using System.Windows;
using System.Windows.Threading;
using ThinkGeo.Core;

namespace MouseWheelOnMarker
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void wpfMap_Loaded(object sender, RoutedEventArgs e)
        {
            wpfMap.MapUnit = GeographyUnit.Meter;

            ThinkGeoCloudVectorMapsOverlay thinkGeoCloudVectorMapsOverlay = new ThinkGeoCloudVectorMapsOverlay("itZGOI8oafZwmtxP-XGiMvfWJPPc-dX35DmESmLlQIU~", "bcaCzPpmOG6le2pUz5EAaEKYI-KSMny_WxEAe7gMNQgGeN9sqL12OA~~", ThinkGeoCloudVectorMapsMapType.Light);
            wpfMap.Overlays.Add(thinkGeoCloudVectorMapsOverlay);

            double x = -10776836.12;
            double y = 3912348.04;

            LayerOverlay overlay1 = new LayerOverlay();
            overlay1.TileType = TileType.MultiTile;
            InMemoryFeatureLayer featureLayer1 = new InMemoryFeatureLayer();
            featureLayer1.InternalFeatures.Add(new Feature(x, y));
            featureLayer1.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyle.CreateSimplePointStyle(PointSymbolType.Circle, GeoColors.Red, 14);
            featureLayer1.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            overlay1.Layers.Add(featureLayer1);

            LayerOverlay overlay2 = new LayerOverlay();
            overlay2.TileType = TileType.MultiTile;
            InMemoryFeatureLayer featureLayer2 = new InMemoryFeatureLayer();
            LineShape lineShape = new LineShape(new Vertex[] { new Vertex(x, y), new Vertex(x + 10, y + 21) });
            Feature lineFeature = new Feature(lineShape);
            featureLayer2.InternalFeatures.Add(lineFeature);
            featureLayer2.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyle.CreateSimpleLineStyle(GeoColors.AliceBlue, 3, false);
            featureLayer2.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            overlay2.Layers.Add(featureLayer2);

            wpfMap.Overlays.Add(overlay1);
            wpfMap.Overlays.Add(overlay2);

            Random r = new Random();
            
            DispatcherTimer timer1 = new DispatcherTimer();
            timer1.Interval = TimeSpan.FromMilliseconds(3000);
            timer1.Tick += (object ss, EventArgs ee) =>
            {
                int randomNumber = r.Next(45, 95);
                x += randomNumber;
                y += randomNumber;
                featureLayer1.InternalFeatures.Add(new Feature(x, y));
                featureLayer2.InternalFeatures.Remove(lineFeature);
                lineShape.Vertices.Add(new Vertex(x, y));
                lineFeature = new Feature(lineShape);
                featureLayer2.InternalFeatures.Add(lineFeature);
                overlay2.Refresh();
                overlay1.Refresh();
            };
            timer1.Start();
            wpfMap.CurrentExtent = new RectangleShape(-10777475.2202498, 3913096.30354198, -10776180.5680905, 3912067.98665154);
            wpfMap.Refresh();
        }
    }
}
